## lomiri-online-accounts 0.12

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(lomiri-online-accounts VERSION 0.12 LANGUAGES CXX)

# Version to put into .pc (pkg-config) files
set(PC_FILE_VERSION ${PROJECT_VERSION})

set(QT_VERSION 5)

option(ENABLE_DOC "Build documentation" ON)
option(ENABLE_MIRCLIENT "Enable support of Mir 1.x mirclient API" OFF)
option(ENABLE_UBUNTU_COMPAT "Enable compatibility with Ubuntu.OnlineAccounts" OFF)
option(DISABLE_TESTS_THAT_FAIL_ON_UBUNTU_NOBLE "Nasty Ubuntu 24.04 hack, tst_libaccounts_service fails on Ubuntu 24.04" OFF)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -Wextra -std=c++11")

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.

include(GNUInstallDirs)
include(FindPkgConfig)

find_package(Qt5
    COMPONENTS Core DBus Gui Network Qml Quick Xml
    REQUIRED)
pkg_check_modules(APPARMOR libapparmor REQUIRED)

set(CMAKE_AUTOMOC ON)

set(ONLINE_ACCOUNTS_PLUGIN_DIR ${CMAKE_INSTALL_FULL_DATADIR}/accounts/qml-plugins)

set(LOA_I18N_DOMAIN "${PROJECT_NAME}")
set(SIGNONUI_I18N_DOMAIN "signon-ui")

add_subdirectory(online-accounts)
add_subdirectory(online-accounts-client)
add_subdirectory(online-accounts-daemon)
add_subdirectory(online-accounts-plugins)
add_subdirectory(online-accounts-service)
add_subdirectory(online-accounts-ui)
add_subdirectory(po)

if(ENABLE_DOC)
    add_subdirectory(doc)
endif()

if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )

    # We add -g when building with coverage so valgrind reports line numbers.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g" )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g" )
endif()

if (BUILD_TESTING)
    enable_testing()
    find_package(Qt${QT_VERSION} COMPONENTS Test REQUIRED)
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
    add_subdirectory(tests)
endif()

include(EnableCoverageReport)
if(cmake_build_type_lower MATCHES coverage)
    ENABLE_COVERAGE_REPORT(TARGETS OnlineAccountsDaemon OnlineAccountsQt OnlineAccountsQML accountd FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

=== debian/changelog ===
lomiri-online-accounts (0.12-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1074113).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 23 Jun 2024 12:26:14 +0200

=== debian/control ===
Source: lomiri-online-accounts
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake (>= 3.5),
               debhelper-compat (= 13),
               dbus-test-runner <!nocheck>,
               pkgconf,
               qml-module-sso-onlineaccounts,
               libaccounts-qt5-dev (>= 1.15),
               libapparmor-dev,
               libglib2.0-dev,
               libnotify-dev,
               libqtdbusmock1-dev,
               libqtdbustest1-dev,
               libsignon-qt5-dev,
               qtbase5-dev (>= 5.4),
               qtdeclarative5-dev,
               qttools5-dev-tools,
               signon-plugins-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-online-accounts
Vcs-Git: https://gitlab.com/ubports/development/core/lomiri-online-accounts.git
Vcs-Browser: https://gitlab.com/ubports/development/core/lomiri-online-accounts

Package: liblomiri-online-accounts-daemon1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends},
Description: Lomiri Online Accounts simplified API - library
 D-Bus service implementing the simplified Online Accounts API.
 .
 This package contains the API implementation of Lomiri's simplified
 Online Accounts API.

Package: liblomiri-online-accounts-daemon-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-online-accounts-daemon1 (= ${binary:Version}),
Description: Online Accounts simplified API (bindings development files)
 D-Bus service implementing the simplified Online Accounts API.
 .
 This module contains the necessary files for developing client libraries
 interfacing with the simplified Online Accounts API.

Package: liblomiri-online-accounts-qt5-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-online-accounts-daemon1 (= ${binary:Version}),
Pre-Depends: ${misc:Pre-Depends},
Description: Library for the simplified Online Accounts API
 The LomiriOnlineAccounts Qt5 library offers an Qt-based API for
 applications to use the Lomiri Online Accounts functionality.

Package: liblomiri-online-accounts-qt5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-online-accounts-qt5-1 (= ${binary:Version}),
Pre-Depends: ${misc:Pre-Depends},
Description: Library for the simplified Online Accounts API - development files
 The OnlineAccounts library offers an Qt-based API for applications to use
 the Online Accounts functionality.

Package: qml-module-lomiri-onlineaccounts
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtquick2,
Description: Online Accounts API for QML applications
 This module provides access to the new Online Accounts API from QML
 applications.

Package: qml-module-lomiri-onlineaccounts-doc
Section: doc
Build-Profiles: <!cross>
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Online Accounts API, HTML documentation
 This module provides access to the new Online Accounts API from QML
 applications.
 .
 This package contains the HTML documentation.

Package: liblomiri-online-accounts-client1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Library to interact with the Lomiri Online Accounts panel
 The LomiriOnlineAccountsClient library offers an API for applications to
 invoke the Lomiri's Online Accounts system settings in order to request
 the creation/configuration of accounts.

Package: liblomiri-online-accounts-client-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-online-accounts-client1 (= ${binary:Version}),
Description: Library to interact with the Lomiri Online Accounts panel - development files
 The LomiriOnlineAccountsClient library offers an API for applications to
 invoke the Lomiri's Online Accounts system settings in order to request
 the creation/configuration of accounts.
 .
 This package contains the development headers for the
 LomiriOnlineAccountsClient library.

Package: qml-module-lomiri-onlineaccounts-client
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtquick2,
Description: Lomiri Online Accounts panel library for QML applications
 This QML module offers an API for applications to invoke Lomiri's Online
 Accounts system settings in order to request the creation/configuration
 of accounts.

Package: qml-module-lomiri-onlineaccounts-client-doc
Build-Profiles: <!nodoc>
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: Lomiri Online Accounts panel library for QML applications - documentation
 This QML module offers an API for applications to invoke Lomiri's Online
 Accounts system settings in order to request the creation/configuration
 of accounts.
 .
 This package contains the developer documentation of
 qml-module-lomiri-onlineaccounts-client.

Package: liblomiri-online-accounts-plugin1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Online Accounts plugin module for Lomiri
 The LomiriOnlineAccounts plugin system provides Lomiri applications with online
 accounts settings via a central setup mechanism in Lomiri System Settings.
 .
 This package ships the shared library of the Lomiri Online Accounts
 plugin system.

Package: liblomiri-online-accounts-plugin-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-online-accounts-plugin1 (= ${binary:Version}),
Description: Online Accounts plugin module for Lomiri - development files
 The LomiriOnlineAccounts plugin system provides Lomiri applications with online
 accounts settings via a central setup mechanism in Lomiri System Settings.
 .
 This module contains the necessary files for developing such Lomiri
 Online Accounts plugins.

Package: qml-module-lomiri-onlineaccounts-plugin
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtquick2,
Description: Online Accounts plugin module for Lomiri - QML module
 The LomiriOnlineAccounts plugin system provides Lomiri applications with online
 accounts settings via a central setup mechanism in Lomiri System Settings.
 .
 This QML module offers the necessary API for using the Lomiri Online
 Accounts plugin system in QML applications.

Package: lomiri-online-accounts-client
Section: misc
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-online-accounts-client1 (= ${binary:Version}),
         lomiri-online-accounts-client-common (>= ${source:Version}),
Description: Tools to interact with the Lomiri Online Accounts panel
 The LomiriOnlineAccountsClient library offers an API for applications to
 invoke the Lomiri's Online Accounts system settings in order to request
 the creation/configuration of accounts.
 .
 This package contains tools using the library so that lomiri-system-settings
 and Lomiri Online Accounts can interact with one another.

Package: lomiri-online-accounts-client-common
Architecture: all
Depends: ${misc:Depends},
Description: Tools to interact with the Lomiri Online Accounts panel - translation files
 The LomiriOnlineAccountsClient library offers an API for applications to
 invoke the Lomiri's Online Accounts system settings in order to request
 the creation/configuration of accounts.
 .
 This package contains localization files for LomiriOnlineAccountsClient
 tools.

## lomiri-online-accounts 0.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-online-accounts VERSION 0.12 LANGUAGES CXX)
+project(lomiri-online-accounts VERSION 0.13 LANGUAGES CXX)
 
 # Version to put into .pc (pkg-config) files
 set(PC_FILE_VERSION ${PROJECT_VERSION})
@@ -26,7 +26,7 @@
 
 set(CMAKE_AUTOMOC ON)
 
-set(ONLINE_ACCOUNTS_PLUGIN_DIR ${CMAKE_INSTALL_FULL_DATADIR}/accounts/qml-plugins)
+set(ONLINE_ACCOUNTS_PLUGIN_DIR ${CMAKE_INSTALL_FULL_DATADIR}/lomiri-online-accounts/qml-plugins)
 
 set(LOA_I18N_DOMAIN "${PROJECT_NAME}")
 set(SIGNONUI_I18N_DOMAIN "signon-ui")

=== tests/CMakeLists.txt ===
set(XVFB_COMMAND)
find_program(XVFBRUN xvfb-run)
find_program(XAUTH xauth)
if((XVFBRUN) AND (XAUTH))
  set(XVFB_COMMAND ${XVFBRUN} -s "-screen 0 640x480x24" -a)
else()
  message(WARNING "Cannot find xvfb-run.")
endif()

add_subdirectory(online-accounts)
add_subdirectory(online-accounts-client)
add_subdirectory(online-accounts-daemon)
add_subdirectory(online-accounts-plugins)
add_subdirectory(online-accounts-service)
add_subdirectory(online-accounts-ui)

=== online-accounts-service/src/CMakeLists.txt ===
project(LomiriOnlineAccountsService LANGUAGES CXX)

pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)
pkg_check_modules(SIGNONQT libsignon-qt${QT_VERSION} REQUIRED)
pkg_check_modules(APPARMOR libapparmor REQUIRED)
pkg_check_modules(GLIB20 glib-2.0 REQUIRED)
pkg_check_modules(NOTIFY libnotify REQUIRED)
pkg_check_modules(SIGNONPLUGINSCOMMON signon-plugins-common REQUIRED)

set(LOA_SERVICE lomiri-online-accounts-service)
set(LOA_UI lomiri-online-accounts-ui)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${LomiriOnlineAccountsDaemon_SOURCE_DIR}/..
)

add_definitions(
    ${ACCOUNTSQT_CFLAGS}
    ${SIGNONQT_CFLAGS}
    ${APPARMOR_CFLAGS}
    ${GLIB20_CFLAGS}
    ${NOTIFY_CFLAGS}
    ${SIGNONPLUGINSCOMMON_CFLAGS}
)

add_definitions(-DSIGNONUI_I18N_DOMAIN="${SIGNONUI_I18N_DOMAIN}")
add_definitions(-DDEBUG_ENABLED)
add_definitions(-DLOA_UI="${LOA_UI}")
add_definitions(-DINSTALL_BIN_DIR="${CMAKE_INSTALL_BINARY_DIR}")
add_definitions(-DQT_NO_KEYWORDS)

set(LOA_SERVICE_SOURCES
    inactivity-timer.cpp
    indicator-service.cpp
    libaccounts-service.cpp
    main.cpp
    notification.cpp
    reauthenticator.cpp
    request.cpp
    request-manager.cpp
    service.cpp
    signonui-service.cpp
    ui-proxy.cpp
    utils.cpp
)

set(LOA_SERVICE_HEADERS
    inactivity-timer.h
    indicator-service.h
    libaccounts-service.h
    notification.h
    reauthenticator.h
    request.h
    request-manager.h
    service.h
    signonui-service.h
    ui-proxy.h
    utils.h
)

set(DBUS_ADAPTOR_SOURCES
    onlineaccountsuiadaptor.cpp
    webcredentialsadaptor.cpp
)
set(DBUS_ADAPTOR_HEADERS
    onlineaccountsuiadaptor.h
    webcredentialsadaptor.h
)

qt_add_dbus_adaptor(DBUS_ADAPTOR_SOURCES com.lomiri.OnlineAccountsUi.xml service.h OnlineAccountsUi::Service)
qt_add_dbus_adaptor(DBUS_ADAPTOR_SOURCES com.canonical.indicators.webcredentials.xml indicator-service.h SignOnUi::IndicatorService)

set (COMMON_SOURCES
    ${CMAKE_SOURCE_DIR}/online-accounts-common/debug.cpp
    ${CMAKE_SOURCE_DIR}/online-accounts-common/i18n.cpp
    ${CMAKE_SOURCE_DIR}/online-accounts-common/ipc.cpp
)
set (COMMON_HEADERS
    ${CMAKE_SOURCE_DIR}/online-accounts-common/debug.h
    ${CMAKE_SOURCE_DIR}/online-accounts-common/globals.h
    ${CMAKE_SOURCE_DIR}/online-accounts-common/i18n.h
    ${CMAKE_SOURCE_DIR}/online-accounts-common/ipc.h
)

if (ENABLE_MIRCLIENT)
    pkg_check_modules(MIRCLIENT REQUIRED mir1client mirclient)
    add_definitions(${MIRCLIENT_CFLAGS})
    set(MIRCLIENT_SOURCES
        mir-helper.cpp
        mir-helper.h
    )
else()
    set(MIRCLIENT_SOURCES
        mir-helper-stub.cpp
        mir-helper.h
    )
    set(MIRCLIENT_LDFLAGS "")
endif()


add_executable(${LOA_SERVICE}
    ${COMMON_SOURCES}
    ${COMMON_HEADERS}
    ${DBUS_ADAPTOR_SOURCES}
    ${DBUS_ADAPTOR_HEADERS}
    ${MIRCLIENT_SOURCES}
    ${LOA_SERVICE_SOURCES}
    ${LOA_SERVICE_HEADERS}
)
target_link_libraries(${LOA_SERVICE}
    Qt${QT_VERSION}::DBus
    Qt${QT_VERSION}::Network
    Qt${QT_VERSION}::Xml
    lomiri-online-accounts-daemon
    ${ACCOUNTSQT_LDFLAGS}
    ${SIGNONQT_LDFLAGS}
    ${APPARMOR_LDFLAGS}
    ${GLIB20_LDFLAGS}
    ${NOTIFY_LDFLAGS}
    ${SIGNONPLUGINSCOMMON_LDFLAGS}
    ${MIRCLIENT_LDFLAGS}
)

set_target_properties(${LOA_SERVICE} PROPERTIES AUTOMOC TRUE)

install(TARGETS ${LOA_SERVICE}
        RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
)

set(LOA_SERVICE_SERVICE_FILE com.lomiri.OnlineAccounts.Manager.service)
configure_file(${LOA_SERVICE_SERVICE_FILE}.in ${CMAKE_CURRENT_BINARY_DIR}/${LOA_SERVICE_SERVICE_FILE} @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LOA_SERVICE_SERVICE_FILE}
    DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/services/
)

set(LOA_UI_SERVICE_FILE com.lomiri.OnlineAccountsUi.service)
configure_file(${LOA_UI_SERVICE_FILE}.in ${CMAKE_CURRENT_BINARY_DIR}/${LOA_UI_SERVICE_FILE} @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LOA_UI_SERVICE_FILE}
        DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/services/
)

set(DBUSIFACEDIR "${CMAKE_INSTALL_DATADIR}/dbus-1/interfaces/")

install(FILES
        com.lomiri.OnlineAccountsUi.xml
        DESTINATION ${DBUSIFACEDIR}
)

install(FILES
        com.canonical.indicators.webcredentials.xml
        DESTINATION ${DBUSIFACEDIR}
)

=== tests/online-accounts-ui/CMakeLists.txt ===
add_subdirectory(tst_access_model)
add_subdirectory(tst_browser_request)
add_subdirectory(tst_notification)
add_subdirectory(tst_provider_request)
# FIXME add_subdirectory(tst_qmlplugin) (help needed!!!)
add_subdirectory(tst_signonui_request)

=== tests/online-accounts-ui/tst_qmlplugin/CMakeLists.txt ===
pkg_check_modules(LIBNOTIFY libnotify REQUIRED)
pkg_check_modules(GLIB20 glib-2.0 REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
)

# tst_qmlplugin

set(TEST tst_qmlplugin)

set(SOURCES
    tst_online_accounts_qml.cpp
)

add_definitions(-DSOURCE_MODULE_PATH="${CMAKE_CURRENT_SOURCE_DIR}")
add_definitions(-DQUICK_TEST_SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")
add_definitions(-DTEST_DATA_DIR="{CMAKE_CURRENT_BINARY_DIR}/data")

add_executable(${TEST} ${SOURCES})

target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::Quick
    Qt${QT_VERSION}::Test
    Qt${QT_VERSION}QuickTest
)

# Prepare QML module loading test bed...
add_custom_command(
        TARGET ${TEST} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy
                ${CMAKE_CURRENT_SOURCE_DIR}/Source/qmldir
                ${CMAKE_CURRENT_BINARY_DIR}/Source/qmldir
        COMMAND ${CMAKE_COMMAND} -E copy
                ${CMAKE_CURRENT_SOURCE_DIR}/testPlugin/Main.qml
                ${CMAKE_CURRENT_BINARY_DIR}/testPlugin/Main.qml
)

set(QML_TEST_CASES
    tst_AccountCreationPage.qml
    tst_AuthorizationPage.qml
    tst_SignOnUiDialog.qml
)

# copy qml files over to build dir to be able to import them uninstalled
foreach(_file ${QML_TEST_CASES})
    add_custom_command(TARGET ${TEST} POST_BUILD
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different
                       ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       ${CMAKE_CURRENT_BINARY_DIR}/${_file})
endforeach(_file)

add_test(${TEST} ${XVFB_COMMAND} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== debian/changelog ===
lomiri-online-accounts (0.13-1) unstable; urgency=medium

  * New upstream release.
  * debian/liblomiri-online-accounts-plugin-dev.examples:
    + White-space fix at EOF.
  * debian/control:
    + Add to D (all dev:pkgs): Requirements as requested via .pc files.
    + Assure same version of liblomiri-online-accounts-daemon is installed
      with lomiri-online-accounts-client bin:pkg.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 24 Jun 2024 17:47:54 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libqtdbusmock1-dev,
                libqtdbustest1-dev,
                libsignon-qt5-dev,
-               qtbase5-dev (>= 5.4),
+               qtbase5-dev (>= 5.15),
                qtdeclarative5-dev,
                qttools5-dev-tools,
                signon-plugins-dev,
@@ -47,6 +47,8 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          liblomiri-online-accounts-daemon1 (= ${binary:Version}),
+         libaccounts-qt5-dev (>= 1.15),
+         qtbase5-dev (>= 5.15),
 Description: Online Accounts simplified API (bindings development files)
  D-Bus service implementing the simplified Online Accounts API.
  .
@@ -71,6 +73,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          liblomiri-online-accounts-qt5-1 (= ${binary:Version}),
+         qtbase5-dev (>= 5.15),
 Pre-Depends: ${misc:Pre-Depends},
 Description: Library for the simplified Online Accounts API - development files
  The OnlineAccounts library offers an Qt-based API for applications to use
@@ -115,6 +118,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          liblomiri-online-accounts-client1 (= ${binary:Version}),
+         qtbase5-dev (>= 5.15),
 Description: Library to interact with the Lomiri Online Accounts panel - development files
  The LomiriOnlineAccountsClient library offers an API for applications to
  invoke the Lomiri's Online Accounts system settings in order to request
@@ -165,6 +169,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          liblomiri-online-accounts-plugin1 (= ${binary:Version}),
+         qtbase5-dev (>= 5.15),
 Description: Online Accounts plugin module for Lomiri - development files
  The LomiriOnlineAccounts plugin system provides Lomiri applications with online
  accounts settings via a central setup mechanism in Lomiri System Settings.
@@ -190,6 +195,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          liblomiri-online-accounts-client1 (= ${binary:Version}),
+         liblomiri-online-accounts-daemon1 (= ${binary:Version}),
          lomiri-online-accounts-client-common (>= ${source:Version}),
 Description: Tools to interact with the Lomiri Online Accounts panel
  The LomiriOnlineAccountsClient library offers an API for applications to

## lomiri-online-accounts 0.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-online-accounts VERSION 0.13 LANGUAGES CXX)
+project(lomiri-online-accounts VERSION 0.14 LANGUAGES CXX)
 
 # Version to put into .pc (pkg-config) files
 set(PC_FILE_VERSION ${PROJECT_VERSION})
@@ -31,6 +31,7 @@
 set(LOA_I18N_DOMAIN "${PROJECT_NAME}")
 set(SIGNONUI_I18N_DOMAIN "signon-ui")
 
+add_subdirectory(click-hooks)
 add_subdirectory(online-accounts)
 add_subdirectory(online-accounts-client)
 add_subdirectory(online-accounts-daemon)

=== online-accounts-service/src/CMakeLists.txt ===
--- 
+++ 
@@ -86,7 +86,7 @@
 )
 
 if (ENABLE_MIRCLIENT)
-    pkg_check_modules(MIRCLIENT REQUIRED mir1client mirclient)
+    pkg_search_module(MIRCLIENT REQUIRED mir1client mirclient)
     add_definitions(${MIRCLIENT_CFLAGS})
     set(MIRCLIENT_SOURCES
         mir-helper.cpp

=== online-accounts-ui/src/CMakeLists.txt ===
project(LomiriOnlineAccountsUi LANGUAGES CXX)

pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)
pkg_check_modules(SIGNONQT libsignon-qt${QT_VERSION} REQUIRED)
pkg_check_modules(APPARMOR libapparmor REQUIRED)
pkg_check_modules(NOTIFY libnotify REQUIRED)
pkg_check_modules(SIGNONPLUGINSCOMMON signon-plugins-common REQUIRED)

set(UI "lomiri-online-accounts-ui")

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/online-accounts-plugins/lib
)

add_definitions(
    ${ACCOUNTSQT_CFLAGS}
    ${SIGNONQT_CFLAGS}
    ${APPARMOR_CFLAGS}
    ${NOTIFY_CFLAGS}
    ${SIGNONPLUGINSCOMMON_CFLAGS}
)

add_definitions(-DLOA_I18N_DOMAIN="${LOA_I18N_DOMAIN}")
add_definitions(-DSIGNONUI_I18N_DOMAIN="${SIGNONUI_I18N_DOMAIN}")
add_definitions(-DDEBUG_ENABLED)
add_definitions(-DOAU_PLUGIN_DIR="${LomiriOnlineAccountsPlugin_PLUGIN_DIR}")
add_definitions(-DPLUGIN_PRIVATE_MODULE_DIR="${LomiriOnlineAccountsPlugin_PLUGIN_PRIVATE_MODULE_DIR}")

set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined")
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

set(UI_SOURCES
    access-model.cpp
    browser-request.cpp
    dialog.cpp
    dialog-request.cpp
    external-browser-request.cpp
    main.cpp
    provider-request.cpp
    request.cpp
    signonui-request.cpp
    ui-server.cpp
)

set(COMMON_SOURCES
    ${CMAKE_SOURCE_DIR}/online-accounts-common/debug.cpp
    ${CMAKE_SOURCE_DIR}/online-accounts-common/i18n.cpp
    ${CMAKE_SOURCE_DIR}/online-accounts-common/ipc.cpp
)

set(UI_QML_SOURCES
    qml/AccountCreationPage.qml
    qml/AuthorizationPage.qml
    qml/ProviderRequest.qml
    qml/SignOnUiPage.qml
)

if (QT_VERSION STREQUAL "5")
    qt5_add_resources(UI_RESOURCES ui.qrc)
endif()

add_executable(${UI}
    ${COMMON_SOURCES}
    ${UI_SOURCES}
    ${UI_RESOURCES}
)
target_link_libraries(${UI}
    Qt${QT_VERSION}::DBus
    Qt${QT_VERSION}::Gui
    Qt${QT_VERSION}::Qml
    Qt${QT_VERSION}::Quick
    lomiri-online-accounts-plugin
    ${ACCOUNTSQT_LDFLAGS}
    ${SIGNONQT_LDFLAGS}
    ${APPARMOR_LDFLAGS}
    ${NOTIFY_LDFLAGS}
    ${SIGNONPLUGINSCOMMON_LDFLAGS}
)
set_target_properties(${UI} PROPERTIES AUTOMOC TRUE)


configure_file(${UI}.desktop.in ${UI}.desktop @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${UI}.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications)

# Install

install(TARGETS ${UI}
        RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
)

=== online-accounts-client/lib/module/CMakeLists.txt ===
project(LomiriOnlineAccountsClientQML LANGUAGES CXX)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${LomiriOnlineAccountsClient_SOURCE_DIR}/..
)

set(CLIENT_MODULE LomiriOnlineAccountsClientQML)
set(API_URI Lomiri.OnlineAccounts.Client)

add_library(${CLIENT_MODULE} MODULE
    plugin.cpp
)

set_target_properties(${CLIENT_MODULE} PROPERTIES
     LINK_FLAGS -Wl,--no-undefined
)

target_link_libraries(${CLIENT_MODULE}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::Qml
    Qt${QT_VERSION}::Quick
    lomiri-online-accounts-client
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmldir.in ${CMAKE_CURRENT_BINARY_DIR}/qmldir @ONLY)

# Module install

set(QT_INSTALL_QML "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION}/qml")
set(PLUGIN_IMPORTS_DIR "${QT_INSTALL_QML}/Lomiri/OnlineAccounts/Client")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir DESTINATION ${PLUGIN_IMPORTS_DIR})
install(TARGETS ${CLIENT_MODULE} DESTINATION ${PLUGIN_IMPORTS_DIR})

=== online-accounts-plugins/lib/module/CMakeLists.txt ===
project(LomiriOnlineAccountsPluginQML LANGUAGES CXX)

pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${LomiriOnlineAccountsPlugin_SOURCE_DIR}/..
)

set(PLUGIN_MODULE LomiriOnlineAccountsPluginQML)
set(API_VER 1.0)
set(API_URI Lomiri.OnlineAccounts.Plugin)

add_definitions(
    ${ACCOUNTSQT_CFLAGS}
)

add_library(${PLUGIN_MODULE} MODULE
    plugin.cpp
    qml-loopback-server.cpp
)

set_target_properties(${PLUGIN_MODULE} PROPERTIES
    LINK_FLAGS -Wl,--no-undefined
)

target_link_libraries(${PLUGIN_MODULE}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::Qml
    Qt${QT_VERSION}::Quick
    lomiri-online-accounts-plugin
    ${ACCOUNTSQT_LDFLAGS}
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmldir.in ${CMAKE_CURRENT_BINARY_DIR}/qmldir @ONLY)

set(QML_FILES_PLUGIN_MODULE
    ChromedWebView.qml
    DuplicateAccount.qml
    ErrorItem.qml
    KeyboardRectangle.qml
    OAuthMain.qml
    OAuth.qml
    Options.qml
    RemovalConfirmation.qml
    ServiceItem.qml
    ServiceItemBase.qml
    ServiceSwitches.qml
    StandardAnimation.qml
    WebView.qml
)

# Module install

set(QT_INSTALL_QML "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION}/qml")
set(PLUGIN_IMPORTS_DIR "${QT_INSTALL_QML}/Lomiri/OnlineAccounts/Plugin")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir DESTINATION ${PLUGIN_IMPORTS_DIR})
install(TARGETS ${PLUGIN_MODULE} DESTINATION ${PLUGIN_IMPORTS_DIR})
install(FILES ${QML_FILES_PLUGIN_MODULE} DESTINATION ${PLUGIN_IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files over to build dir to be able to import them uninstalled
  foreach(_file ${QML_FILES_PLUGIN_MODULE})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(${PLUGIN_MODULE}_copy_files_to_build_dir DEPENDS ${QML_FILES_PLUGIN_MODULE})
  add_dependencies(${PLUGIN_MODULE} ${PLUGIN_MODULE}_copy_files_to_build_dir)
endif()

=== tests/click-hooks/online-accounts-hooks/CMakeLists.txt ===
set(TEST tst_online-accounts-hooks)
set(SOURCES
    tst_online_accounts_hooks.cpp
)

pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)

add_executable(${TEST} ${SOURCES})
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${ACCOUNTSQT_INCLUDE_DIRS}
)
add_definitions(
    -DHOOK_PROCESS="${lomiri-online-accounts-hooks_BINARY_DIR}/lomiri-online-accounts-hooks"
)
add_dependencies(${TEST} lomiri-online-accounts-hooks)

target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::Xml
    Qt${QT_VERSION}::Test
    ${ACCOUNTSQT_LIBRARIES}
)

set_target_properties(${TEST} PROPERTIES AUTOMOC TRUE)
add_test(${TEST} ${XVFB_COMMAND} dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== tests/click-hooks/online-accounts-hooks2/CMakeLists.txt ===
set(TEST tst_online-accounts-hooks2)
set(SOURCES
    tst_online_accounts_hooks2.cpp
)

pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)
pkg_check_modules(SIGNONQT libsignon-qt${QT_VERSION} REQUIRED)
pkg_check_modules(QTDBUSMOCK REQUIRED libqtdbusmock-1)
pkg_check_modules(QTDBUSTEST REQUIRED libqtdbustest-1)

add_executable(${TEST} ${SOURCES})
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${ACCOUNTSQT_INCLUDE_DIRS}
    ${SIGNONQT_INCLUDE_DIRS}
    ${QTDBUSMOCK_INCLUDE_DIRS}
    ${QTDBUSTEST_INCLUDE_DIRS}
)
add_definitions(
    -DHOOK_PROCESS="${lomiri-online-accounts-hooks2_BINARY_DIR}/lomiri-online-accounts-hooks2"
    -DSIGNOND_MOCK_TEMPLATE="${CMAKE_CURRENT_SOURCE_DIR}/signond.py"
)
add_dependencies(${TEST} lomiri-online-accounts-hooks2)

target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::DBus
    Qt${QT_VERSION}::Xml
    Qt${QT_VERSION}::Test
    ${ACCOUNTSQT_LIBRARIES}
    ${SIGNONQT_LIBRARIES}
    ${QTDBUSMOCK_LIBRARIES}
    ${QTDBUSTEST_LIBRARIES}
)

set_target_properties(${TEST} PROPERTIES AUTOMOC TRUE)
add_test(${TEST} ${XVFB_COMMAND} dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== tests/online-accounts-daemon/functional_tests/CMakeLists.txt ===
add_subdirectory(daemon)

set(TEST tst_daemon)
set(SOURCES
    daemon_interface.cpp
    functional_tests.cpp
)

pkg_check_modules(QTDBUSMOCK REQUIRED libqtdbusmock-1)
pkg_check_modules(QTDBUSTEST REQUIRED libqtdbustest-1)
pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)

add_executable(${TEST} ${SOURCES})
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${LomiriOnlineAccountsQt_SOURCE_DIR}/..
    ${LomiriOnlineAccountsDaemon_SOURCE_DIR}/..
    ${ACCOUNTSQT_INCLUDE_DIRS}
    ${QTDBUSMOCK_INCLUDE_DIRS}
    ${QTDBUSTEST_INCLUDE_DIRS}
)
add_definitions(
    -DTEST_DBUS_CONFIG_FILE="${CMAKE_CURRENT_BINARY_DIR}/data/testsession.conf"
    -DTEST_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
    -DTEST_PROCESS="${CMAKE_CURRENT_SOURCE_DIR}/test_process.py"
    -DSIGNOND_MOCK_TEMPLATE="${CMAKE_CURRENT_SOURCE_DIR}/signond.py"
    -DDBUS_APPARMOR_MOCK_TEMPLATE="${CMAKE_CURRENT_SOURCE_DIR}/dbus_apparmor.py"
    -DONLINE_ACCOUNTS_SERVICE_MOCK_TEMPLATE="${CMAKE_CURRENT_SOURCE_DIR}/online_accounts-service.py"
)
add_dependencies(${TEST} loa-accountd)

configure_file(data/testsession.conf.in data/testsession.conf)
configure_file(data/com.lomiri.OnlineAccounts.Manager.service.in
    data/com.lomiri.OnlineAccounts.Manager.service
)
configure_file(loa-accountd-wrapper.in ${CMAKE_CURRENT_BINARY_DIR}/loa-accountd-wrapper)

target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::DBus
    Qt${QT_VERSION}::Test
    lomiri-online-accounts-qt${QT_VERSION}
    ${ACCOUNTSQT_LIBRARIES}
    ${QTDBUSMOCK_LIBRARIES}
    ${QTDBUSTEST_LIBRARIES}
)

set_target_properties(${TEST} PROPERTIES AUTOMOC TRUE)
add_test(${TEST} ${XVFB_COMMAND} dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== tests/online-accounts-plugins/lib/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LomiriOnlineAccountsPlugin_SOURCE_DIR}/..
    ${ACCOUNTSQT_INCLUDE_DIRS}
    ${QTDBUSMOCK_INCLUDE_DIRS}
    ${QTDBUSTEST_INCLUDE_DIRS}
)

# tst_application_manager

set(TEST tst_application_manager)
set(SOURCES
    tst_application_manager.cpp
    ${LomiriOnlineAccountsPlugin_SOURCE_DIR}/application-manager.cpp
    ${LomiriOnlineAccountsPlugin_SOURCE_DIR}/account-manager.cpp
)

pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)
pkg_check_modules(QTDBUSMOCK REQUIRED libqtdbusmock-1)
pkg_check_modules(QTDBUSTEST REQUIRED libqtdbustest-1)

add_definitions(-DTEST_DATA_DIR="${CMAKE_CURRENT_BINARY_DIR}/data")

add_executable(${TEST} ${SOURCES})
target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::Qml
    Qt${QT_VERSION}::Test
    lomiri-online-accounts-qt${QT_VERSION}
    ${ACCOUNTSQT_LIBRARIES}
    ${QTDBUSMOCK_LIBRARIES}
    ${QTDBUSTEST_LIBRARIES}
)

add_test(${TEST} ${XVFB_COMMAND} dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== tests/online-accounts-service/tst_inactivity_timer/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${LomiriOnlineAccountsService_SOURCE_DIR}
)

# tst_inactivity_timer

set(TEST tst_inactivity_timer)
set(SOURCES
    tst_inactivity_timer.cpp
    ${LomiriOnlineAccountsService_SOURCE_DIR}/inactivity-timer.cpp
)
add_executable(${TEST} ${SOURCES})
target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::Test
)
add_test(${TEST} ${XVFB_COMMAND} dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== tests/online-accounts-service/tst_libaccounts_service/CMakeLists.txt ===
pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${LomiriOnlineAccountsService_SOURCE_DIR}
    ${ACCOUNTSQT_INCLUDE_DIRS}
)

# tst_libaccounts_service

set(TEST tst_libaccounts_service)
set(SOURCES
    ${CMAKE_SOURCE_DIR}/online-accounts-common/debug.cpp
    ${LomiriOnlineAccountsService_SOURCE_DIR}/libaccounts-service.cpp
    ${LomiriOnlineAccountsService_SOURCE_DIR}/libaccounts-service.h
    tst_libaccounts_service.cpp
)

add_executable(${TEST} ${SOURCES})
target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::DBus
    Qt${QT_VERSION}::Test
    Qt${QT_VERSION}::Xml
    ${ACCOUNTSQT_LIBRARIES}
)
set_target_properties(${TEST} PROPERTIES AUTOMOC TRUE)
add_test(${TEST} ${XVFB_COMMAND} dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== tests/online-accounts-service/tst_service/CMakeLists.txt ===
pkg_check_modules(ACCOUNTSQT accounts-qt${QT_VERSION} REQUIRED)
pkg_check_modules(APPARMOR libapparmor REQUIRED)
pkg_check_modules(SIGNONPLUGINSCOMMON signon-plugins-common REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${LomiriOnlineAccountsService_SOURCE_DIR}
    ${ACCOUNTSQT_INCLUDE_DIRS}
    ${APPARMOR_INCLUDE_DIRS}
    ${SIGNONPLUGINSCOMMON_INCLUDE_DIRS}
)

# tst_service

set(TEST tst_service)
set(SOURCES
    ${CMAKE_CURRENT_BINARY_DIR}/onlineaccountsuiadaptor.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/onlineaccountsuiadaptor.h
    ${LomiriOnlineAccountsService_SOURCE_DIR}/request.cpp
    ${LomiriOnlineAccountsService_SOURCE_DIR}/request.h
    ${LomiriOnlineAccountsService_SOURCE_DIR}/request-manager.cpp
    ${LomiriOnlineAccountsService_SOURCE_DIR}/request-manager.h
    ${LomiriOnlineAccountsService_SOURCE_DIR}/service.cpp
    ${LomiriOnlineAccountsService_SOURCE_DIR}/service.h
    ${LomiriOnlineAccountsService_SOURCE_DIR}/ui-proxy.h
    ${LomiriOnlineAccountsService_SOURCE_DIR}/utils.cpp
    ${LomiriOnlineAccountsService_SOURCE_DIR}/utils.h
    tst_service.cpp
)

add_definitions(-DNO_REQUEST_FACTORY)

qt_add_dbus_adaptor(SOURCES ${LomiriOnlineAccountsService_SOURCE_DIR}/com.lomiri.OnlineAccountsUi.xml service.h OnlineAccountsUi::Service)

add_executable(${TEST} ${SOURCES})
target_link_libraries(${TEST}
    Qt${QT_VERSION}::Core
    Qt${QT_VERSION}::DBus
    Qt${QT_VERSION}::Test
    Qt${QT_VERSION}::Xml
    ${ACCOUNTSQT_LIBRARIES}
    ${APPARMOR_LIBRARIES}
    ${SIGNONPLUGINSCOMMON_LIBRARIES}
)
set_target_properties(${TEST} PROPERTIES AUTOMOC TRUE)
add_test(${TEST} ${XVFB_COMMAND} dbus-test-runner -t ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
add_dependencies(check ${TEST})

=== debian/changelog ===
lomiri-online-accounts (0.14-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/control:
    + Update B-Ds for added click-hooks code and re-enabled online-accounts-
      ui/tst_qmlplugin in upstream release v0.14.
    + Add B: (lomiri-online-accounts-client): lomiri-system-settings-online-
      accounts (<< 0.12~). (Closes: #1074537).
  * debian/lomiri-online-accounts-client.install:
    + Update for added click-hooks.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 17 Jul 2024 09:14:35 +0200

## lomiri-online-accounts 0.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-online-accounts VERSION 0.14 LANGUAGES CXX)
+project(lomiri-online-accounts VERSION 0.15 LANGUAGES CXX)
 
 # Version to put into .pc (pkg-config) files
 set(PC_FILE_VERSION ${PROJECT_VERSION})
@@ -27,9 +27,20 @@
 set(CMAKE_AUTOMOC ON)
 
 set(ONLINE_ACCOUNTS_PLUGIN_DIR ${CMAKE_INSTALL_FULL_DATADIR}/lomiri-online-accounts/qml-plugins)
+set(ONLINE_ACCOUNTS_PLUGIN_PRIVATE_MODULE_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/lomiri-online-accounts/private)
 
 set(LOA_I18N_DOMAIN "${PROJECT_NAME}")
 set(SIGNONUI_I18N_DOMAIN "signon-ui")
+
+include(JoinPaths)
+join_paths(PC_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
+join_paths(PC_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
+
+execute_process(
+    COMMAND qmake -query QT_INSTALL_QML
+    OUTPUT_VARIABLE QT_INSTALL_QML
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+)
 
 add_subdirectory(click-hooks)
 add_subdirectory(online-accounts)
@@ -55,10 +66,10 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g" )
 endif()
 
+set(CTEST_TEST_TARGET_ALIAS "check" CACHE STRING "An alias for the built-in test target.")
+include(CTest)
 if (BUILD_TESTING)
-    enable_testing()
     find_package(Qt${QT_VERSION} COMPONENTS Test REQUIRED)
-    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
     add_subdirectory(tests)
 endif()

=== po/CMakeLists.txt ===
include(FindGettext)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if("${GETTEXT_XGETTEXT_EXECUTABLE}" STREQUAL "GETTEXT_XGETTEXT_EXECUTABLE-NOTFOUND")
    message(FATAL_ERROR "Could not find xgettext")
endif()

set(DOMAIN ${LOA_I18N_DOMAIN})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY)

add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --from-code=UTF-8
                          --c++
                          --qt
                          --add-comments=TRANSLATORS
                          --keyword=_ --keyword=tr --keyword=tr:1,2 --keyword=dtr:2
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_FULL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== doc/online-accounts/CMakeLists.txt ===
add_custom_target(doc-daemon ALL
                  COMMAND ${QDOC_EXECUTABLE}
                  -outputdir ${CMAKE_CURRENT_BINARY_DIR}/html
                  ${CMAKE_CURRENT_SOURCE_DIR}/lomiri-onlineaccounts2.qdocconf)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
        DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/qml-module-lomiri-onlineaccounts)

=== online-accounts-client/lib/CMakeLists.txt ===
add_subdirectory(LomiriOnlineAccountsClient)
add_subdirectory(module)

=== online-accounts-service/src/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 add_definitions(-DSIGNONUI_I18N_DOMAIN="${SIGNONUI_I18N_DOMAIN}")
 add_definitions(-DDEBUG_ENABLED)
 add_definitions(-DLOA_UI="${LOA_UI}")
-add_definitions(-DINSTALL_BIN_DIR="${CMAKE_INSTALL_BINARY_DIR}")
+add_definitions(-DINSTALL_BIN_DIR="${CMAKE_INSTALL_FULL_BINDIR}")
 add_definitions(-DQT_NO_KEYWORDS)
 
 set(LOA_SERVICE_SOURCES

=== online-accounts-ui/src/CMakeLists.txt ===
--- 
+++ 
@@ -25,8 +25,8 @@
 add_definitions(-DLOA_I18N_DOMAIN="${LOA_I18N_DOMAIN}")
 add_definitions(-DSIGNONUI_I18N_DOMAIN="${SIGNONUI_I18N_DOMAIN}")
 add_definitions(-DDEBUG_ENABLED)
-add_definitions(-DOAU_PLUGIN_DIR="${LomiriOnlineAccountsPlugin_PLUGIN_DIR}")
-add_definitions(-DPLUGIN_PRIVATE_MODULE_DIR="${LomiriOnlineAccountsPlugin_PLUGIN_PRIVATE_MODULE_DIR}")
+add_definitions(-DOAU_PLUGIN_DIR="${ONLINE_ACCOUNTS_PLUGIN_DIR}")
+add_definitions(-DPLUGIN_PRIVATE_MODULE_DIR="${ONLINE_ACCOUNTS_PLUGIN_PRIVATE_MODULE_DIR}")
 
 set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined")
 set(CMAKE_CXX_VISIBILITY_PRESET hidden)

=== online-accounts/lib/CMakeLists.txt ===
add_subdirectory(qml)
add_subdirectory(qt)

=== tests/online-accounts-daemon/CMakeLists.txt ===
#FIXME add_subdirectory(functional_tests) (help needed!!!)

=== tests/online-accounts-service/CMakeLists.txt ===
add_subdirectory(tst_inactivity_timer)
if (NOT DISABLE_TESTS_THAT_FAIL_ON_UBUNTU_NOBLE)
    add_subdirectory(tst_libaccounts_service)
endif()
add_subdirectory(tst_service)
add_subdirectory(tst_signonui_service)
add_subdirectory(tst_ui_proxy)

=== tests/online-accounts-ui/CMakeLists.txt ===
add_subdirectory(tst_access_model)
add_subdirectory(tst_browser_request)
add_subdirectory(tst_notification)
add_subdirectory(tst_provider_request)
add_subdirectory(tst_qmlplugin)
add_subdirectory(tst_signonui_request)

=== tests/online-accounts/CMakeLists.txt ===
add_subdirectory(OnlineAccounts)
add_subdirectory(qml_module)

=== online-accounts-client/lib/LomiriOnlineAccountsClient/CMakeLists.txt ===
project(LomiriOnlineAccountsClient LANGUAGES CXX)

set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined")
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

set(CLIENT_LIB lomiri-online-accounts-client)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${LomiriOnlineAccountsUi}
    ${CMAKE_SOURCE_DIR}/online-accounts-common
)

set(CLIENT_LIB_HEADERS
    global.h
    setup.h
    Setup
)

set(CLIENT_LIB_SOURCES
    OnlineAccountsUi.cpp
    setup.cpp
)

qt_add_dbus_interface(CLIENT_LIB_SOURCES ${CMAKE_SOURCE_DIR}/online-accounts-service/src/com.lomiri.OnlineAccountsUi.xml OnlineAccountsUi)

add_library(${CLIENT_LIB} SHARED
    ${CLIENT_LIB_SOURCES}
)
set_target_properties(${CLIENT_LIB} PROPERTIES
    VERSION 1.0.0
    SOVERSION 1
    LINK_FLAGS -Wl,--no-undefined
)

target_link_libraries(${CLIENT_LIB}
    Qt${QT_VERSION}::DBus
    Qt${QT_VERSION}::Gui
)

set_target_properties(${CLIENT_LIB} PROPERTIES AUTOMOC TRUE)
# Install

install(TARGETS ${CLIENT_LIB}
        LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
)

# Development files

configure_file(${PROJECT_NAME}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig)

install(
    FILES ${CLIENT_LIB_HEADERS}
    DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/${CLIENT_LIB}/${PROJECT_NAME}"
)

=== debian/changelog ===
lomiri-online-accounts (0.15-2) unstable; urgency=medium

  * debian/control:
    + Update B-D: on libsignon-qt5-dev and signon-plugins-dev and let it
      depend on version 8.61+git20231015.c8ad982-7~. (Closes: #1086781).
    .
    An interesting observation here is that signon-plugins-dev is
    actually a Qt6 component of signond since
    8.61+git20231015.c8ad982-7~exp1. However, only signon-plugins-common.pc
    is used from this dev:pkg and this does not explicitly enforce linking
    against Qt6. Only the headers get used from /usr/include/SignOn, no
    shared library involved. And as these headers are still usable with Qt5 +
    Qt6, this can easily go well when they are used by parts of
    lomiri-online-accounts.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 11 Dec 2024 23:40:20 +0100

lomiri-online-accounts (0.15-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 31 Aug 2024 05:11:25 +0200

=== debian/control ===
--- 
+++ 
@@ -8,19 +8,22 @@
                debhelper-compat (= 13),
                dbus-test-runner <!nocheck>,
                pkgconf,
-               qml-module-sso-onlineaccounts,
                libaccounts-qt5-dev (>= 1.15),
                libapparmor-dev,
+               libclick-dev,
                libglib2.0-dev,
                libnotify-dev,
                libqtdbusmock1-dev,
                libqtdbustest1-dev,
-               libsignon-qt5-dev,
+               libsignon-qt5-dev (>= 8.61+git20231015.c8ad982-7~),
+               qml-module-sso-onlineaccounts <!nocheck>,
+               qml-module-lomiri-test <!nocheck>,
                qtbase5-dev (>= 5.15),
                qtdeclarative5-dev,
                qttools5-dev-tools,
-               signon-plugins-dev,
+               signon-plugins-dev (>= 8.61+git20231015.c8ad982-7~),
                xauth <!nocheck>,
+               xmldiff:native <!nocheck>,
                xvfb <!nocheck>,
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
@@ -197,6 +200,7 @@
          liblomiri-online-accounts-client1 (= ${binary:Version}),
          liblomiri-online-accounts-daemon1 (= ${binary:Version}),
          lomiri-online-accounts-client-common (>= ${source:Version}),
+Breaks: lomiri-system-settings-online-accounts (<< 0.12~),
 Description: Tools to interact with the Lomiri Online Accounts panel
  The LomiriOnlineAccountsClient library offers an API for applications to
  invoke the Lomiri's Online Accounts system settings in order to request

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

NULL =

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	export DEB_BUILD_PROFILES := cross
	CONFIGURE_OPTS += -DENABLE_DOC="OFF"
endif

# UBports-specific:
#
# The online-accounts-client/client/service/tst_libaccounts_service/ unit
# tests fails on Ubuntu noble. Skip this for now.
#
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
        CONFIGURE_OPTS += -DDISABLE_TESTS_THAT_FAIL_ON_UBUNTU_NOBLE=ON
endif

# Skip tests on the archs they are known to be flaky with current configuration
# See https://launchpad.net/bugs/1630906
testskip_architectures :=

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_TESTING=ON \
	    $(CONFIGURE_OPTS) \
	    $(NULL)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	mkdir -p debian/home
	-dh_auto_test --no-parallel
else
	mkdir -p debian/home
	dh_auto_test --no-parallel
endif
endif

override_dh_install:
	# empty directories
	rmdir debian/tmp/usr/share/doc/qml-module-lomiri-onlineaccounts/html/images/
	rmdir debian/tmp/usr/share/doc/qml-module-lomiri-onlineaccounts-client/html/images/
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_clean:
	rm -Rf debian/home
	dh_clean

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
